/* UW9 - Operator Services uw-src/add_operinfo.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void add_nickinfo(char *nick, char *user, char *host, char *base64, char *num, char *server, char *name)
{
   struct nickinfo *new, *current;
   new = (struct nickinfo *) calloc(1, sizeof(struct nickinfo));
   if(new != NULL) 
   {
      new->next = NULL;
      strcpy(new->nick, nick);
      strcpy(new->user, user);
      strcpy(new->host, host);
      strcpy(new->base64, base64);
      strcpy(new->numeric, num);
      strcpy(new->server, server);
      strcpy(new->name, name);
      new->is_oper=FALSE;
      strcpy(new->away, "H");
      number++;
      if(number > maxnumber) 
      {
	 maxnumber = number;
	 write_maxuser();
      }
      new->chanhead = NULL;
      if(nickhead == NULL) nickhead = new;
      else 
      {
	 current = nickhead;
	 while(current->next != NULL) current = current->next;
	 current->next = new;
      }
      clone_check(new->host, nick);
   }
   else log(ERRLOG_FILE, "[%s] Adding new nick: Out of memory\n", date());
}

   void add_joininfo(char *chan, char *num, int is_ops)
   {
      struct nickinfo *nick;
      struct chaninfo *new, *current;
      char *nwho = NULL;

      nwho = num2nick(num);
      incroomcnt(chan);
      if(nickhead == NULL) return;
      nick = nickhead;
      while(nick != NULL)
      {
	 if(!strcasecmp(nwho, nick->nick))
	 {
	    new = (struct chaninfo *) calloc(1, sizeof(struct chaninfo));
	    if(new != NULL)
	    {
	       new->next = NULL;
	       new->is_ops = is_ops;
	       strcpy(new->channel, chan);
	       if(nick->chanhead == NULL) nick->chanhead = new;
	       else 
	       {
		  current = nick->chanhead;
		  while(current->next != NULL) current = current->next;
		  current->next = new;
	       }
	    }
	 }
	 nick = nick->next;
      }
   }

int add_oper_addrinfo(char *nick, char *address)
{
   struct operinfo *oper, *opertest;
   struct adderinfo *new, *current, *addrtest;
   char raddr[100];
   int got_one = 0;

   raddr[0] = '\0';
   opertest = operhead;
   while(opertest != NULL)
   {
      if(!strcasecmp(nick, opertest->nick))
      {
	 addrtest = opertest->adderhead;
	 while(addrtest != NULL)
	 {
	    if(!strcasecmp(address, addrtest->address)) return 1;
	    collapse(address);
	    if(!bancmp(address, addrtest->address) || !bancmp(addrtest->address, address))
	    {
	       if(strlen(address) < strlen(addrtest->address))
	       {
		  strcpy(raddr, addrtest->address);
		  got_one = 1;
	       }
	       else return 1;
	    }
	    addrtest = addrtest->next;
	 }
      }
      opertest = opertest->next;
   }
   if(got_one)
      delete_addrnode(nick, raddr);
   got_one = 0;
   oper = operhead;
   while(oper != NULL)
   {
      if(!strcasecmp(nick, oper->nick))
      {
	 new = (struct adderinfo *) calloc(1, sizeof(struct adderinfo));
	 if(new != NULL)
	 {
	    new->next = NULL;
	    strcpy(new->address, address);
	    if(oper->adderhead == NULL) oper->adderhead = new;
	    else
	    {
	       current = oper->adderhead;
	       while(current->next != NULL) current = current->next;
	       current->next = new;
	    }
	 }
	 else log(ERRLOG_FILE, "[%s] Adding Addr: Out of memory\n", date());
      }
      oper = oper->next;
   }
   return 0;
}

   void add_operinfo(char *nick, int lvl, int suspend, long lastseen)
   {
      struct operinfo *new, *current;

      new = (struct operinfo *) calloc(1, sizeof(struct operinfo));
      if(new != NULL)
      {
	 new->next = NULL;
	 strcpy(new->nick, nick);
	 new->level = lvl;
	 new->suspend = suspend;
	 new->lastseen = lastseen;
	 new->adderhead = NULL;
	 if(operhead == NULL) operhead = new;
	 else
	 {
	    current = operhead;
	    while(current->next != NULL) current = current->next;
	    current->next = new;
	 }
      }
      else log(ERRLOG_FILE, "[%s] Adding User: Out of memory\n", date());
   }
