/* UW9 - Operator Services uw-src/add_protect.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void add_prot(char *who, char *rest)
{
   struct protinfo *new, *current;
   char *nick, *server, *helpname, *nwho;

   nwho=nick2num(who);
   helpname = get_command_name("addprot");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   nick = strtok(rest, " ");
   server = strtok(NULL, " ");
   if(server == NULL)
   {
      do_help(who, helpname);
      return;
   }
   current = prothead;
   while(current != NULL)
   {
      if(!strcasecmp(current->nick, nick))
      {
	 send_to_server(":%s NOTICE %s :That Nick is already protected\n", bot.nick, nwho);
	 return;
      }
      current = current->next;
   }
   add_protinfo(nick, server);
   send_to_server(":%s NOTICE %s :Protected Nicks added\n", bot.nick, nwho);
   write_protinfo();
}

void del_prot(char *who, char *rest)
{
   char *nick, *helpname, *nwho;
   struct protinfo *current, *previous;

   nwho=nick2num(who);
   helpname = get_command_name("delprot");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   current = prothead;
   while(current != NULL)
   {
      if(!strcasecmp(rest, current->nick)) break;
      else
      {
	 previous = current;
	 current = current->next;
      }
   }
   if(current == NULL) return;
   else
   {
      if(current == prothead) prothead = prothead->next;
      else previous->next = current->next;
      free(current);
      send_to_server(":%s NOTICE %s :Protected Nick Removed from list\n", bot.nick, nwho);
      write_protinfo();
   }
}
