/* UW9 - Operator Services uw-src/add_trusted.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void add_trust(char *who, char *rest)
{
   FILE *hfile;
   struct trustinfo *new, *current;
   char *hostmask, *reason, *nwho, *trusted, *helpname;
   int i=0;

   nwho=nick2num(who);
   helpname = get_command_name("addtrust");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   trusted = strtok(rest, " ");
   current = trusthead;
   while(current != NULL)
   {
      if(!bancmp(current->host, trusted) || !bancmp(trusted, current->host))
      {
	 if(!strcasecmp(current->host, trusted))
	 {
	    send_to_server(":%s NOTICE %s :That Host is already in the trusted list\n", bot.nick, nwho);
	    return;
	 }
	 if(strlen(trusted) < strlen(current->host))
	    del_trust(who, current->host);
	 else
	 {
	    send_to_server(":%s NOTICE %s :Trusted Mask already covered by %s\n", bot.nick, nwho, current->host);
	    return;
	 }
      }
      current = current->next;
   }
   add_trustinfo(trusted);
   send_to_server(":%s NOTICE %s :Trusted Host added\n", bot.nick, nwho);
   write_trustinfo();
}

void del_trust(char *who, char *rest)
{
   FILE *fp, *fp2;
   char buff[300], *trusted, *host, *nwho, *helpname;
   struct trustinfo *current, *previous;

   nwho=nick2num(who);
   helpname = get_command_name("deltrust");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   current = trusthead;
   while(current != NULL)
   {
      if(!strcasecmp(rest, current->host)) break;
      else
      {
	 previous = current;
	 current = current->next;
      }
   }
   if(current == NULL) return;
   else
   {
      if(current == trusthead) trusthead = trusthead->next;
      else previous->next = current->next;
      free(current);
      send_to_server(":%s NOTICE %s :Trusted Host Removed from list\n", bot.nick, nwho);
      write_trustinfo();
   }
}
