/* UW9 - Operator Services uw-src/bot.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#define DEF_GLOBALS
#include "bot.h"
#undef DEF_GLOBALS

void sig_alrm(int sig)
{
   char *botnum;
   int i;
   alarmed = 1;
   alarm(ALARMINTERVAL);
   reset_flood();
   if(!reconnect()) 
   {
      if(trk_servers >= no_servers) trk_servers = 0;
      strcpy(bot.server, servers[trk_servers].name);
      bot.port = servers[trk_servers].port;
      trk_servers++;
      if((i = get_connection(bot.server, bot.port)) != -1) 
      {
	 log(LOG_FILE, "[%s] Reconnecting to %s\n", date(), bot.server);
	 socketfd = i;
	 init_bot();
      }
   }

   if((time(NULL) - pingtime) > PINGINTERVAL) 
   {
      sendping();
      pingtime = time(NULL);
   }
   signal(SIGALRM, sig_alrm);
}

void sig_kill(int sig)
{
   log(ERRLOG_FILE, "[%s] SIG KILL\n", date());
   unlink(pid_file);
   exit(0);
}

void sig_term(int sig)
{
   log(ERRLOG_FILE, "[%s] SIG TERM\n", date());
   unlink(pid_file);
   exit(0);
}

void sig_hup(int sig)
{
   log(ERRLOG_FILE, "[%s] SIG HUP\n", date());
   send_to_server(":%s WALLOPS :Got signal SIGHUP, reloading %s conf. file\n", myserver, bot.nick);
   load_cfg();
}

void sig_segv(int sig)
{
   log(ERRLOG_FILE, "[%s] SIG SEGV\n", date());
   exit(0);
}

void sig_pipe(int sig)
{
   log(ERRLOG_FILE, "[%s] SIG PIPE\n", date());
   signal(SIGPIPE, sig_pipe);
}

void sig_bus(int sig)
{
   log(ERRLOG_FILE, "[%s] SIG BUS\n", date());
   signal(SIGBUS, sig_bus);
}

main(int argc, char **argv)
{
   struct timeval timeout;
   struct stat stbuf;
   fd_set fdvar;
   srand(time(NULL));
   botstart = lasttime = uptime = savetime = pingtime = time(NULL);
   signal(SIGSEGV, sig_segv);
   signal(SIGHUP, sig_hup);
   signal(SIGBUS, sig_bus);
   signal(SIGPIPE, sig_pipe);
   signal(SIGALRM, sig_alrm);
   signal(SIGTERM, sig_term);
   signal(SIGKILL, sig_kill);
   if(fork()) exit(0);
   load_cfg();
   load_nums();
   load_opers();
   switch(argc) 
   {
   case 1: 
      socketfd = get_connection(bot.server, bot.port);
      if(socketfd == -1) exit(0);
      break;
   case 2: 
      socketfd = get_connection(argv[1], bot.port);
      if(socketfd == -1) exit(0);
      strcpy(bot.server, argv[1]);
      break;
   case 3: 
      socketfd = get_connection(argv[1], atoi(argv[2]));
      if(socketfd == -1) exit(0);
      strcpy(bot.server, argv[1]);
      break;
   }
   load_maxuser();
   init_bot();

   while(1) 
   {
      timeout.tv_sec = WAITSEC;
      timeout.tv_usec = UWAITSEC;
      FD_ZERO(&fdvar);
      FD_SET(socketfd, &fdvar);
      switch(select(NFDBITS, &fdvar, (fd_set *) 0, (fd_set *) 0, &timeout)) 
      {
      case  0: 
	 break;
      case -1: 
	 if(!alarmed) 
	 {
	    sleep(RECHECK);
	    sig_alrm(0);
	 }
	 else alarmed = 0;
	 break;
      default: 
	 parse_server_msg(&fdvar);
	 break;
      }
   }
}
