/* UW9 - Operator Services uw-src/load_files.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void load_jupe()
{
   FILE *fp;
   char tmp[300], buff[300],  *user, *host, *usernum, *reason, *tmpnum;
   char srvnum;
   int numeric;

   if((fp = fopen(JP_FILE, "r")) == NULL)
   {
      file_error(JP_FILE);
      return;
   }
   while(fgets(buff, 10000, fp) != NULL)
   {
      strip_newline(buff);
      if(host = strchr(buff, ' ')) *host++ = '\0';
      if(tmpnum = strchr(host, ' ')) *tmpnum++ = '\0';
      if(reason = strchr(tmpnum, ' ')) *reason++ = '\0';
      send_to_server("%c SQUIT %s :Juped by %s\n",convert2y[server_num], host, myserver);
      send_to_server("%c SQUIT %s 0 :Juped by %s\n",convert2y[server_num], host, myserver);
      serv_unused(host);
      numeric = atoi(tmpnum);
      srvnum=get_free_servnum(host, convert2y[numeric]);
      if(srvnum == '\0')
      {
	 send_to_server(":%s WALLOPS :Numeric for %s in use, please re-jupe\n", myserver, host);
	 return;
      }
      send_to_server("%c SERVER %s %d 0 %ld P10 %cD] :JUPE - %s\n",convert2y[server_num], host, HOPCOUNT + 1, time(NULL), srvnum, reason);
      add_jupeinfo(buff, host, numeric, reason);
   }
   fclose(fp);
}

void load_resv()
{
   FILE *fp;
   char tmp[300], buff[300],  *user, *host, *usernum, *reason;

   if((fp = fopen(RESV_FILE, "r")) == NULL)
   {
      file_error(RESV_FILE);
      return;
   }
   while(fgets(buff, 10000, fp) != NULL)
   {
      strip_newline(buff);
      if(user = strchr(buff, ' ')) *user++ = '\0';
      if(host = strchr(user, ' ')) *host++ = '\0';
      if(reason = strchr(host, ' ')) *reason++ = '\0';
      usernum=get_free_usernum(buff);
      add_resvinfo(buff, user, host, reason);
      send_to_server("%c NICK %s 1 780000000 %s %s DQx8MG %s :%s\n", convert2y[server_num], buff, user, host, usernum, reason);
      add_nickinfo(buff, user, host, "DQx8MG", usernum, myserver, reason);
   }
   fclose(fp);
}

void load_opers(char *who, char *rest)
{
   FILE *fp;
   char *nick, *lvl, *suspend, *seen, *addr, buff[1000];

   if((fp = fopen(OPER_FILE, "r")) == NULL)
   {
      file_error(OPER_FILE);
      return;
   }
   while(fgets(buff, 10000, fp) != NULL)
   {
      strip_newline(buff);
      nick = strtok(buff, " ");
      lvl = strtok(NULL, " ");
      suspend = strtok(NULL, " ");
      seen = strtok(NULL, " ");
      add_operinfo(nick, atoi(lvl), atoi(suspend), atol(seen));
      while((addr = strtok(NULL, " ")) != NULL)
      {
	 add_oper_addrinfo(nick, addr);
      }
   }
   fclose(fp);
}

void load_glines()
{
   FILE *fp;
   char buff[3000], *nick, *host, *gtime, *reason;
   struct ginfo *new, *current;
   long dtime, newtime;

   if((fp = fopen(G_FILE, "r")) == NULL)
   {
      file_error(G_FILE);
      return;
   }
   while(fgets(buff, 10000, fp) != NULL)
   {
      strip_newline(buff);
      if(host = strchr(buff, ' ')) *host++ = '\0';
      if(gtime = strchr(host, ' ')) *gtime++ = '\0';
      if(reason = strchr(gtime, ' ')) *reason++ = '\0';
      dtime = atol(gtime) - time(NULL);
      newtime=atol(gtime);
      send_to_server(":%s GLINE * +%s %ld :%s\n", myserver, host, dtime, reason);
      add_glineinfo(buff, host, atoi(gtime), reason, ctime((time_t *)&newtime));
   }
   fclose(fp);
}

void load_secretchan()
{
   FILE *fp;
   struct secretinfo *new, *current;
   char buff[300], *chan;

   if((fp = fopen(S_FILE, "r")) == NULL)
   {
      file_error(S_FILE);
      return;
   }
   while(fgets(buff, 10000, fp) != NULL)
   {
      strip_newline(buff);
      new = (struct secretinfo *) calloc(1, sizeof(struct secretinfo));
      if(new != NULL)
      {
	 new->next = NULL;
	 strcpy(new->channel, buff);
	 if(secrethead == NULL) secrethead = new;
	 else
	 {
	    current = secrethead;
	    while(current->next != NULL) current = current->next;
	    current->next = new;
	 }
      }
      else log(ERRLOG_FILE, "[%s] Adding new secret Channel: Out of memory\n", date());
   }
}

   void load_killchan()
   {
      FILE *fp;
      struct killinfo *new, *current;
      char buff[300], *chan;

      if((fp = fopen(K_FILE, "r")) == NULL)
      {
	 file_error(K_FILE);
	 return;
      }
      while(fgets(buff, 10000, fp) != NULL)
      {
	 strip_newline(buff);
	 new = (struct killinfo *) calloc(1, sizeof(struct killinfo));
	 if(new != NULL)
	 {
	    new->next = NULL;
	    strcpy(new->channel, buff);
	    if(killhead == NULL) killhead = new;
	    else
	    {
	       current = killhead;
	       while(current->next != NULL) current = current->next;
	       current->next = new;
	    }
	 }
	 else log(ERRLOG_FILE, "[%s] Adding new Kill Channel: Out of memory\n", date());
      }
   }

   void load_badchan()
   {
      FILE *fp;
      struct badinfo *new, *current;
      char buff[300], *chan;

      if((fp = fopen(B_FILE, "r")) == NULL)
      {
	 file_error(B_FILE);
	 return;
      }
      while(fgets(buff, 10000, fp) != NULL)
      {
	 strip_newline(buff);
	 new = (struct badinfo *) calloc(1, sizeof(struct badinfo));
	 if(new != NULL)
	 {
	    new->next = NULL;
	    strcpy(new->channel, buff);
	    if(badhead == NULL) badhead = new;
	    else
	    {
	       current = badhead;
	       while(current->next != NULL) current = current->next;
	       current->next = new;
	    }
	 }
	 else log(ERRLOG_FILE, "[%s] Adding new Bad Channel: Out of memory\n", date());
      }
   }

   void load_protect()
   {
      FILE *fp;
      struct protinfo *new, *current;
      char buff[300], *server, *nick;

      if((fp = fopen(PROT_FILE, "r")) == NULL)
      {
	 file_error(PROT_FILE);
	 return;
      }
      while(fgets(buff, 10000, fp) != NULL)
      {
	 strip_newline(buff);
	 nick = strtok(buff, " ");
	 server = strtok(NULL, " ");
	 new = (struct protinfo *) calloc(1, sizeof(struct protinfo));
	 if(new != NULL)
	 {
	    new->next = NULL;
	    strcpy(new->nick, nick);
	    strcpy(new->server, server);
	    if(prothead == NULL) prothead = new;
	    else
	    {
	       current =prothead;
	       while(current->next != NULL) current = current->next;
	       current->next = new;
	    }
	 }
	 else log(ERRLOG_FILE, "[%s] Adding new Protected host: Out of memory\n", date());
      }
   }

   void load_trusted()
   {
      FILE *fp;
      struct trustinfo *new, *current;
      char buff[300], *host;

      if((fp = fopen(H_FILE, "r")) == NULL)
      {
	 file_error(H_FILE);
	 return;
      }
      while(fgets(buff, 10000, fp) != NULL)
      {
	 strip_newline(buff);
	 new = (struct trustinfo *) calloc(1, sizeof(struct trustinfo));
	 if(new != NULL)
	 {
	    new->next = NULL;
	    strcpy(new->host, buff);
	    if(trusthead == NULL) trusthead = new;
	    else
	    {
	       current =trusthead;
	       while(current->next != NULL) current = current->next;
	       current->next = new;
	    }
	 }
	 else log(ERRLOG_FILE, "[%s] Adding new trusted host: Out of memory\n", date());
      }
   }

   void load_maxuser()
   {
      FILE *fp;
      char buff[10000], *tmp;

      if((fp = fopen(MAX_FILE, "r")) == NULL)
      {
	 file_error(MAX_FILE);
	 return;
      }
      while(fgets(buff, 10000, fp) != NULL)
      {
	 strip_newline(buff);
	 if(tmp = strchr(buff, ' ')) *tmp++ = '\0';
	 strcpy(maxdate, tmp);
	 maxnumber = atoi(buff);
      }
   }
