/* UW9 - Operator Services uw-src/mkpasswd.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include<bot.h>

void get_crypt(char *who, char *rest)
{
   char *cryptpass, *pass, *helpname, *nwho;

   nwho = nick2num(who);
   helpname = get_command_name("mkpasswd");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   pass = strtok(rest, " ");
   if(strlen(pass) > 8)
   {
       send_to_server(":%s NOTICE %s :Password can only be 8 characters\n", bot.nick, nwho);
       return;
   }
   cryptpass = mkpass(pass, "0");
   send_to_server(":%s NOTICE %s :The password %s was encrypted to: %s\n", bot.nick, nwho, pass, cryptpass);
}

char *crypt(const char *key, const char *salt);

char *mkpass(char *password, char *keys)
{
   static char saltChars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
   char salt[3];

   if (strlen(keys) < 2) {
      srandom(time(0));
      salt[0] = saltChars[random() % 64];
      salt[1] = saltChars[random() % 64];
      salt[2] = 0;
   }
   else {
      salt[0] = keys[0];
      salt[1] = keys[1];
      salt[2] = '\0';
      if ((strchr(saltChars, salt[0]) == NULL) || (strchr(saltChars, salt[1]) == NULL))
	 fprintf(stderr, "illegal salt %s\n", salt), exit(1);
   }
   if ((strchr(saltChars, salt[0]) == NULL) || (strchr(saltChars, salt[1]) == NULL))
      fprintf(stderr, "illegal salt %s\n", salt), exit(1);

   return (crypt(password, salt));
}
