/* UW9 - Operator Services uw-src/parse_privmsg.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_privmsg(char *who, char *rest)
{
   /* rest = bot.nick :command #channel arg1 arg2 etc */
   struct nickinfo *nick;
   int i;
   char *msg, *cmd, *nwho, *helpname, *mwho;

   nick = return_nickinfo(who);
   nwho=nick2num(who);
   if(check_flood(who)) return;  /* you flooding me? go away! */
   trailing_blanks(rest);        /* get rid of those trailing blanks */
   if(cmd = strchr(rest, ':')) *cmd++ = '\0';
   else return;
   if(msg = strchr(cmd, ' ')) *msg++ = '\0';
   else msg = NULL;
   if(msg != NULL && *msg == ' ')
   {
      send_to_server(":%s NOTICE %s :You have to many spaces directly after the command.\n", bot.nick, nwho, cmd);
      return;
   }
   if(strlen(cmd) > 99)
   {
      return;
   }
#ifdef DEBUG
   printf("Parse Privmsg - Command: [%s] Who: [%s] Msg: [%s]\n", cmd, who, msg);
#endif
         if(strstr(cmd, "DCC"))
         {
            return;
         }
   for(i = 0; *commands[i].name; i++)
   {
      if(!strcasecmp(commands[i].name, cmd))
      {
	 if(commands[i].disable)
	 {
	    send_to_server(":%s NOTICE %s :The command %s has been disabled.\n", bot.nick, nwho, cmd);
	    return;
	 }
	 if(commands[i].needarg && msg == NULL)
	 {
	    do_help(who, cmd);
	    return;
	 }
	 if(!check_access(who, msg, commands[i].level, cmd)) return;
         trailing_blanks(rest);        /* get rid of those trailing blanks */
	 command_log(who, cmd, rest);
         if(strstr(cmd, "TIME"))
         {
            clone_ctcp_time(who, rest);
            return;
         }
         if(strstr(cmd, "USERINFO"))
         {
            clone_ctcp_userinfo(who, rest);
            return;
         }
         if(strstr(cmd, "CLIENTINFO"))
         {
            clone_ctcp_clientinfo(who, rest);
            return;
         }
         if(strstr(cmd, "FINGER"))
         {
            clone_ctcp_finger(who, rest);
            return;
         }
         if(strstr(cmd, "VERSION"))
         {
            ctcp_version(who, rest);
            return;
         }
         if(strstr(cmd, "PING"))
         {
            mwho = num2nick(rest);
            if(!strcasecmp(rest, bot.nick))
               ctcp_ping(who, rest);
            else
               clone_ctcp_ping(who, rest, msg);
            return;
         }
	 commands[i].function(who, msg);
	 return;
      }
   }
   if(!nick->is_oper) return;
   if(!strcasecmp(who, bot.nick) || !strcasecmp(who, myserver)) return;
   if(strcmp(cmd, "DCC"))
   {
     send_to_server(":%s NOTICE %s :The Command [ %s ] is not a proper command.\n", bot.nick, nwho, cmd);
     send_to_server(":%s NOTICE %s :Please ensure you typed it correctly.\n", bot.nick, nwho);
   }
}
