/* UW9 - Operator Services uw-src/parse_srvmsg.c
 * UW9.2 Copyright  1998-2000 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_server_msg(fd_set *read_fds)
{
   int i;
   char *botnum;

   if(FD_ISSET(socketfd, read_fds))
   {
      if(readln() > 0) 
      {
	 parse(line);
      }
      else 
      {

         botnum=get_usernum(bot.nick);
         delete_usernum(botnum);
         free_ginfo();
         free_jupeinfo();
         free_resvinfo();
         free_badchan();
         free_killchan();
         free_secret();
         free_trusted();
         free_hublist();
         free_protlist();
         free_roomlist();
         free_nicklist();
         if(trk_servers >= no_servers) trk_servers = 0;
         strcpy(bot.server, servers[trk_servers].name);
         bot.port = servers[trk_servers].port;
         trk_servers++;
         if((i = get_connection(bot.server, bot.port)) != -1)
         {
            log(LOG_FILE, "[%s] Reconnecting to %s\n", date(), bot.server);
            socketfd = i;
            init_bot();
         }
      }
   }
}
void parse_ping(char *who, char *rest)
{
   send_to_server("PONG %s\n", who);
   bot.server_active = TRUE;
}


void parse_pong(char *who, char *rest)
{
   char *ptr = NULL;
   if(ptr = strchr(rest, ' ')) *ptr = '\0';
   if(!strcasecmp(who, rest)) bot.server_active = TRUE;
}

void parse_squit(char *who, char *rest)
{
   char *server = NULL, *nwho;

   free_maplist();
   send_to_server(":%s MAP\n", bot.nick);
   log(SQTLOG_FILE, "[%s] HUB: %s SQUIT %s\n", date(), who, rest);
   server = strtok(rest, " ");
   remove_hub(server,NULL);
}

void parse_pass(char *who, char *rest)
{
   char *usernum = NULL;

   usernum=get_free_usernum(bot.nick);
   send_to_server("%c NICK %s 1 %lu %s %s DQx8MG %s :%s\n", convert2y[server_num], bot.nick, time(NULL), ircuser, myhost, usernum, ircname);
   add_nickinfo(bot.nick, ircuser, myserver, "DQx8MG", usernum, myserver, reason);
   send_to_server(":%s MODE %s :%s\n", bot.nick, bot.nick, mymodes);
   bot.server_active = TRUE;  
   load_commands();
   load_trusted();
   load_resv();
   load_jupe();
   load_glines();
   load_badchan();
   load_killchan();
   load_secretchan();
   load_protect();
   alarm(ALARMINTERVAL);
}

